/**
 * @description
 * @typedef {Object} WaveElements
 * @property {HTMLDivElement} grid
 * @property {HTMLDivElement} view
 * @property {HTMLDivElement} values
 */

/**
 * @description
 * @typedef {Object} ChangoItem
 * @property {string} kind
 * @property {Array<number | string>} wave
 * @property {WebGLVertexArrayObject} lineVao
 * @property {WebGLVertexArrayObject} maskVao
 */

/**
 * @description 装载在 globalLookup 中的记录 vcd 数据的字典
 * @typedef {Record<string, ChangoItem>} Chango
 */

/**
 * @description 
 * @typedef {Object} WireItem
 * @property {string} kind
 * @property {string} link
 * @property {string} name
 * @property {number} size
 * @property {WireItem} parent
 * @property {string} type
 */

/**
 * @description
 * @typedef {Array<{ ref: string }>} View
 */

/**
 * @description
 * @typedef {Set<WireItem>} CurrentWires
 */

/**
 * @description
 * @typedef {Object} GlobalLookup
 * @property {Chango} chango
 * @property {View} view
 * @property {CurrentWires} currentWires
 * @property {number} time
 */

/**
 * @description
 * @typedef {Object} Pstate
 * @property {number} width
 * @property {number} height
 * @property {number} xScale
 * @property {number} xOffset
 * @property {number} yOffset
 * @property {number} yStep
 * @property {number} yDuty
 */

/**
 * @description
 * @typedef {Object} Rgba
 * @property {number} red
 * @property {number} green
 * @property {number} blue
 * @property {number} alpha
 */

/**
 * @description
 * @typedef {Object} Updater
 * @property {number} index
 * @property {Rgba} rgba
 */

/**
 * @description
 * @typedef {Object} RenderConfig
 * @property {'common' | 'action' | undefined} type
 */

/**
 * @typedef {Object} Handler
 * @property {string} desc
 * @property {(arg1: Pstate, arg2: any) => boolean} fn
 */

/**
 * @typedef {Object} Deso
 * @property {(config: RenderConfig) => void} render
 * 
 */

/**
 * @typedef {'scrollLeft' | 'scrollRight' | 'scrollUp' | 'scrollDown' | 'scaleUp' | 'scaleDown'} EventHandlerKind
 */